<template>
  <v-app class="service">
    <div class="service__title">
      <h1>Услуги</h1>
    </div>

    <!--Поиск услуг-->
    <v-text-field class="service__search" v-model="search" append-icon="mdi-magnify" label="Поиск.." single-line
                  hide-details></v-text-field>

    <!--Список услуг-->
    <v-data-table
        :headers="headers"
        :items="service"
        :search="search"
        class="service__table"
    >
      <template v-slot:top>
        <v-toolbar flat>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" max-width="500px">
            <template v-slot:activator="{ on, attrs }">
              <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">Добавить услугу</v-btn>
            </template>

            <!--Добавление услуги-->
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>

              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="6">
                      <v-text-field v-model="editedItem.name" label="Название" :rules="serviceRules"/>
                    </v-col>
                    <v-col cols="12" sm="6" md="6">
                      <v-text-field v-model="editedItem.price" label="Стоимость" :rules="countRules"/>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>

              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
                <v-btn color="#AFFFCF" @click="save">Сохранить</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!--Удаление записи-->
          <v-dialog v-model="dialogDelete" max-width="510px">
            <v-card>
              <v-card-title class="text-h5">Вы уверены что хотите удалить запись?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="#AFFFCF" @click="closeDelete">Закрыть</v-btn>
                <v-btn color="#AFFFCF" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <!--Иконки с действиями-->
      <template v-slot:item.actions="{ item }">
        <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil</v-icon>
        <v-icon small @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
    </v-data-table>
  </v-app>
</template>

<script>
import {
  mdiPencil,
  mdiDelete,
} from "@mdi/js"
import axios from "axios";

export default {
  name: "Service",
  data() {
    return {
      icons: {
        mdiPencil,
        mdiDelete,
      },

      dialog: false,
      dialogDelete: false,
      serviceRules: [
        v => !!v || 'Заполните это поле',
        v => (v && v.length <= 100) || 'Поле должно содержать 100 символов',
      ],
      countRules: [
        v => !!v || 'Заполните это поле',
        v => /^[+]?[0-9]*\.?[0-9]\d{1,2}/.test(v) || 'Поле должно содержать положительные цифры'
      ],

      service: [],
      search: '',
      editedIndex: -1,

      editedItem: {
        name: '',
        price: '0.00'
      },

      defaultItem: {
        name: '',
        price: '0.00'
      },

      headers: [
        {
          text: 'Название',
          value: 'name',
          sortable: false
        },
        {
          text: 'Стоимость',
          value: 'price'
        },
        {
          text: 'Действия',
          value: 'actions',
          sortable: false
        }
      ]
    }
  },

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? 'Новая запись' : 'Редактировать запись'
    },
  },

  watch: {
    dialog(val) {
      val || this.close()
    },
    dialogDelete(val) {
      val || this.closeDelete()
    },
  },

  mounted() {
    this.fetchService()
  },

  methods: {
    async fetchService() {
      axios
          .get(this.$root.globalVar + '/service')
          .then(response => {
            this.service = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    addService(item) {
      axios.post(this.$root.globalVar + '/service', {
        name: item.name,
        price: item.price
      })
          .then(response => this.service.push(response.data))
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    updateService(item) {
      axios
          .put(this.$root.globalVar + '/service/' + item.id, {
            name: item.name,
            price: item.price
          })
          .then(Object.assign(this.service[this.editedIndex], item))
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    deleteService(item) {
      axios
          .delete(this.$root.globalVar + '/service/' + item.id)
          .catch(error => {
            console.log(error)
          })
      this.service.splice(this.editedIndex, 1)
    },

    editItem(item) {
      this.editedIndex = this.service.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem(item) {
      this.editedIndex = this.service.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    deleteItemConfirm() {
      this.deleteService(this.editedItem)
      this.closeDelete()
    },

    close() {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete() {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    save() {
      if (this.editedItem.name === '' || this.editedItem.price === '') {
        alert('Ошибка! Подробности: введите Наименование и цену')
        throw new Error("Ошибка! Подробности: введите наименование и цену.");
      }

      if (this.editedItem.price <= 0) {
        alert('Ошибка! Подробности: введите данные в верном формате')
        throw new Error("Ошибка! введите данные в верном формате");
      }

      if (this.editedIndex > -1) {
        this.updateService(this.editedItem, this.editedIndex)
      } else {
        this.addService(this.editedItem)
      }
      this.close()
    },
  }
}
</script>

<style lang="scss" scoped>
.service {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__table {
    width: 70%;
    margin: 0 auto;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }
}

.v-text-field {
  flex: 0.2 0 !important;
  margin-top: 30px;
}
</style>